﻿/*
 * Created by SharpDevelop.
 * User: Admin
 * Date: 14.02.2010
 * Time: 5:14
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

using System.IO;
using System.Text;
using System.Globalization;
using System.Threading;

namespace ticks2seconds {
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form {
				
		private System.IO.FileInfo[] ticksFiles;
		
		public MainForm() {
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			dateTimePicker1.Value = DateTime.Now.AddMonths(-1);
			dateTimePicker2.Value = DateTime.Now;
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		void Button1Click(object sender, EventArgs e) {
			button1.Enabled = false;
			Log(null);
			GenerateOutputFile();
			return;
		}
		
		void Log(String text) {
			if (text == null) {
				this.listBox1.Items.Clear();
			}
			else {
				this.listBox1.Items.Add(text);
			}
		}
		
		void GenerateOutputFile() {
			
			try {
				
				System.IO.DirectoryInfo inputDir = new System.IO.DirectoryInfo(textBox1.Text);
				if (!inputDir.Exists) MessageBox.Show("Директория входящих данных не существует");

				System.IO.DirectoryInfo outputDir = new System.IO.DirectoryInfo(textBox3.Text);
				if (!inputDir.Exists) MessageBox.Show("Директория исходящих данных не существует");
				
				ticksFiles = inputDir.GetFiles(textBox2.Text.
					Replace("[Ticker]", textBox6.Text).
					Replace("[FromYYMMDD]", "*").
					Replace("[ToYYMMDD]", "*"));
				System.IO.FileInfo outputFile = new System.IO.FileInfo(outputDir + "\\" + textBox5.Text.
					Replace("[Sec]", textBox4.Text).
					Replace("[Ticker]", textBox6.Text).
					Replace("[FromYYMMDD]", dateTimePicker1.Value.ToString("yyMMdd")).
					Replace("[ToYYMMDD]", dateTimePicker2.Value.ToString("yyMMdd")));
				
//				TimeSpan period = new TimeSpan(dateTimePicker2.Value.Date.AddDays(1).Ticks - dateTimePicker1.Value.Date.Ticks);
//				int daysNum = period.TotalDays;
				
				DateTime dt = new DateTime(dateTimePicker1.Value.Year, dateTimePicker1.Value.Month, dateTimePicker1.Value.Day);
				int daysNum = 0;
				Hashtable hDates = new Hashtable();
				while (dt.CompareTo(dateTimePicker2.Value.Date) <= 0) {
					hDates[dt.ToString("yyMMdd")] = daysNum;
					hDates[dt.ToString("yyyyMMdd")] = daysNum;
					daysNum++;
					dt = dt.AddDays(1);
				}
				string[] sDates = new string[daysNum];
				foreach (DictionaryEntry de in hDates) {
					sDates[int.Parse(de.Value.ToString())] = de.Key.ToString();
				}
				
				int secPeriod = Int32.Parse(textBox4.Text), barsDay = 86399 / secPeriod + 1;
				Bar[,] bars = new Bar[daysNum, barsDay];
				int[] isLoaded = new int[daysNum];
				
				System.Text.RegularExpressions.Regex rx = new System.Text.RegularExpressions.Regex(textBox2.Text.
					Replace("[Ticker]", textBox6.Text).
					Replace("[FromYYMMDD]", @"(\d{6})").
					Replace("[ToYYMMDD]", @"(\d{6})"));
				
				for (int q = 0; q < ticksFiles.Length; q++) {
					
					System.Text.RegularExpressions.Match m = rx.Match(ticksFiles[q].Name);
					if (!m.Success) {
						Log(ticksFiles[q].Name + ": имя файла не соответствует шаблону");
						continue;
					}
					
					DateTime dt1 = DateTime.ParseExact(m.Result("$1"), "yyMMdd", new DateTimeFormatInfo());
					DateTime dt2 = DateTime.ParseExact(m.Result("$2"), "yyMMdd", new DateTimeFormatInfo());
					if (dt1.CompareTo(dateTimePicker2.Value.Date) > 0 || dt2.CompareTo(dateTimePicker1.Value.Date) < 0) {
						Log(ticksFiles[q].Name + " файл вне рассматриваемого диапазона дат");
						continue;
					}
					
					try {
						int fs = (int)ticksFiles[q].Length, p = 0;
	            		using (StreamReader sr = new StreamReader(ticksFiles[q].FullName)) {
		   					String line;
		   					if ((line = sr.ReadLine()) == null) {
		   						Log(ticksFiles[q].Name + ": файл пустой");
								continue;
		   					}
		   					p += line.Length;
		   					String[] cols = line.Trim().Split(new Char[] {','});
		   					int cl = cols.Length, i_ticker = -1, i_date = -1, i_time = -1, i_last = -1, i_vol = -1, lines = 1;
		   					for (int g = 0; g < cols.Length; g++) {
		   						if (cols[g] == "<TICKER>") i_ticker = g;
		   						if (cols[g] == "<DATE>") i_date = g;
		   						if (cols[g] == "<TIME>") i_time = g;
		   						if (cols[g] == "<LAST>") i_last = g;
		   						if (cols[g] == "<VOL>") i_vol = g;
		   					}
		   					if (i_ticker < 0 || i_date < 0 || i_time < 0 || i_last < 0 || i_vol < 0) {
		   						Log(ticksFiles[q].Name + " неверный формат заголовка");
								continue;
		   					}
		   					
		   					while ((line = sr.ReadLine()) != null) {
		   						cols = line.Trim().Split(new Char[] {','});
		   						if (cols.Length != cl || hDates[cols[i_date]] == null) {
		   							continue;
		   						}
		   						int j_date = int.Parse(hDates[cols[i_date]].ToString());
		   						if (isLoaded[j_date] == 1 || cols[i_ticker] != textBox6.Text) {
		   							continue;
		   						}
		   						
		   						if (isLoaded[j_date] < 1) isLoaded[j_date] = 2;
		   						int barNum = (Int32.Parse(cols[i_time].Substring(0, 2)) * 3600 + Int32.Parse(cols[i_time].Substring(2, 2)) * 60 + Int32.Parse(cols[i_time].Substring(4, 2))) / secPeriod;
		   						if (bars[j_date, barNum] == null) {
		   							bars[j_date, barNum] = new Bar(Convert.ToDouble(cols[i_last].Replace('.', ',')), int.Parse(cols[i_vol]));
		   						} else {
		   							bars[j_date, barNum].Update(Convert.ToDouble(cols[i_last].Replace('.', ',')), int.Parse(cols[i_vol]));
		   						}
		   						lines++;
//		   						Log("lines: "+lines.ToString());
								double f = 800.0 / ticksFiles.Length, l = f * p / ticksFiles[q].Length;
								progressBar1.Value = Convert.ToInt32(f * q + l);
							}
		   					
		   					for (int g = 0; g < daysNum; g++) {
		   						if (isLoaded[g] == 2) isLoaded[g] = 1;
		   					}
		        			
		   					Log(ticksFiles[q].Name + ": Обработано строк: " + lines);


						}
					}
        			catch (Exception) {
						continue;
        			}
				}
				

				
				if (outputFile.Exists) outputFile.Delete();
				StreamWriter sw = outputFile.CreateText(); 
	            sw.WriteLine("<TICKER>,<PER>,<DATE>,<TIME>,<OPEN>,<HIGH>,<LOW>,<CLOSE>,<VOL>");
	            
	            for (int q = 0; q < daysNum; q++) {
	            	for (int g = 0; g < barsDay; g++) {
	            		if (bars[q, g] == null) {
	            			continue;
	            		}
	            		
	            		int secs1 = g * secPeriod,
	            			secs2 = secs1 % 3600,
	            			secs3 = secs2 % 60;	         
	            		string s_ticker = textBox6.Text,
	            			s_per = "0",
	            			s_date = sDates[q],
	            			s_time = (secs1 > 35999? "": "0") + (secs1 / 3600).ToString() + (secs2 > 599? "": "0") + (secs2 / 60).ToString() + (secs3 > 9? "": "0") + secs3.ToString(),
	            			s_open = bars[q, g].open.ToString(),
	            			s_high = bars[q, g].high.ToString(),
	            			s_low = bars[q, g].low.ToString(),
	            			s_close = bars[q, g].close.ToString(),
	            			s_vol = bars[q, g].vol.ToString();
	            			
	            		sw.WriteLine(s_ticker+','+s_per+','+s_date+','+s_time+','+s_open+','+s_high+','+s_low+','+s_close+','+s_vol);
	            		progressBar1.Value = 800 + 200 * (q * barsDay + g) / daysNum / barsDay;
	            	}
	            }
		   		Log("Файл данных создан: " + outputFile.Name);
	            
	            sw.Close();
				button1.Enabled = true;
    			progressBar1.Value = 0;
    			return;

         	}
        	catch (Exception) {
				MessageBox.Show("Не удалось создать файл");
				button1.Enabled = true;
        		return;
        	}

		}
	}
}
